/**@file

// cpcMassFlowControllerConfig.ctl
This library contains the import and export function of the CPC_MassFlowController.

@par Creation Date
  dd/mm/yyyy

@par Modification History
  
@par Constraints
  None

@par Usage
  Public

@par PVSS managers
  Ui, CTRL

@author 
  the author (DEP-GROUP)

@copyright
        &copy;Copyright CERN 2013 - all rights reserved
*/
//@{



// Constants
const string UN_CONFIG_CPC_MASSFLOWCONTROLLER_DPT_NAME = "CPC_MassFlowController";
//begin_TAG_SCRIPT_DEVICE_TYPE_constants
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_LENGTH = 44;

const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_UNIT                           = 1;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_FORMAT                         = 2;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_DEADBAND                       = 3;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_DEADBAND_TYPE                  = 4;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_POSST_ARCHIVE_ACTIVE           = 5;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_POSST_ARCHIVE_TIME_FILTER      = 6;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_POSRST_ARCHIVE_ACTIVE          = 5;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_POSRST_ARCHIVE_TIME_FILTER     = 6;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MAXPOSST_ARCHIVE_ACTIVE        = 5;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MAXPOSST_ARCHIVE_TIME_FILTER   = 6;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MPOSRST_ARCHIVE_ACTIVE         = 5;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MPOSRST_ARCHIVE_TIME_FILTER    = 6;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUPOSRST_ARCHIVE_ACTIVE        = 5;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUPOSRST_ARCHIVE_TIME_FILTER   = 6;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ACTOUTOV_ARCHIVE_ACTIVE        = 5;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ACTOUTOV_ARCHIVE_TIME_FILTER   = 6;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_VOTST_UNIT                     = 7;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_VOTST_FORMAT                   = 8;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_VOTST_DEADBAND                 = 9;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_VOTST_DEADBAND_TYPE            = 10;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_VOTST_ARCHIVE_ACTIVE           = 11;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_VOTST_ARCHIVE_TIME_FILTER      = 12;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUVOTOFST_DEADBAND             = 9;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUVOTOFST_DEADBAND_TYPE        = 10;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUVOTOFST_ARCHIVE_ACTIVE       = 11;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUVOTOFST_ARCHIVE_TIME_FILTER  = 12;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUCCRST_ARCHIVE_ACTIVE         = 13;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUCCRST_ARCHIVE_TIME_FILTER    = 14;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUDMORST_ARCHIVE_ACTIVE        = 13;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUDMORST_ARCHIVE_TIME_FILTER   = 14;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUVOTMRST_ARCHIVE_ACTIVE       = 13;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_AUVOTMRST_ARCHIVE_TIME_FILTER  = 14;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MVOTMRST_ARCHIVE_ACTIVE        = 13;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MVOTMRST_ARCHIVE_TIME_FILTER   = 14;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MDMORST_ARCHIVE_ACTIVE         = 13;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MDMORST_ARCHIVE_TIME_FILTER    = 14;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MCCRST_ARCHIVE_ACTIVE          = 13;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_MCCRST_ARCHIVE_TIME_FILTER     = 14;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ACTDMO_ARCHIVE_ACTIVE          = 13;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ACTDMO_ARCHIVE_TIME_FILTER     = 14;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ACTCC_ARCHIVE_ACTIVE           = 13;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ACTCC_ARCHIVE_TIME_FILTER      = 14;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ACTVOTMO_ARCHIVE_ACTIVE        = 13;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ACTVOTMO_ARCHIVE_TIME_FILTER   = 14;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_NORMAL_POSITION                = 15;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_STSREG01               = 16;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_STSREG02               = 17;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_EVSTSREG01             = 18;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_EVSTSREG02             = 19;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_POSST                  = 20;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_POSRST                 = 21;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MAXPOSST               = 22;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MPOSRST                = 23;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_AUPOSRST               = 24;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_AUVOTOFST              = 25;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_AUCCRST                = 26;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_AUDMORST               = 27;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_AUVOTMRST              = 28;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MVOTMRST               = 29;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MDMORST                = 30;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MCCRST                 = 31;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_VOTST                  = 32;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_ACTOUTOV               = 33;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_ACTDMO                 = 34;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_ACTCC                  = 35;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_ACTVOTMO               = 36;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MANREG01               = 37;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MPOSR                  = 38;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MDMOR                  = 39;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MCCR                   = 40;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDRESS_MVOTMOR                = 41;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_DESCRIPTION                    = 42;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_CALIB_UNIT                     = 43;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_CALIB_GAS_NAME                 = 44;

const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDITIONAL_LENGTH          = 7;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDITIONAL_MASKEVENT       = 1;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDITIONAL_PARAMETERS      = 2;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDITIONAL_MASTER_NAME     = 3;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDITIONAL_PARENTS         = 4;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDITIONAL_CHILDREN        = 5;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDITIONAL_TYPE            = 6;
const unsigned UN_CONFIG_CPC_MASSFLOWCONTROLLER_ADDITIONAL_SECOND_ALIAS    = 7;
//end_TAG_SCRIPT_DEVICE_TYPE_constants


/**
DPE configuration
TODO: use fw info instead
*/
mapping CPC_MassFlowControllerConfig_getConfig() {
  mapping config;
  mapping props;

//begin_TAG_SCRIPT_DEVICE_TYPE_deviceConfig
    mappingClear(props);
    props["address"]        = ".ProcessInput.StsReg01";
    props["dataType"]       = CPC_UINT16;
    config["StsReg01"]      = props;

    mappingClear(props);
    props["address"]        = ".ProcessInput.StsReg02";
    props["dataType"]       = CPC_UINT16;
    config["StsReg02"]      = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.evStsReg01";
    props["dataType"]       = CPC_INT32;
    config["evStsReg01"]    = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.evStsReg02";
    props["dataType"]       = CPC_INT32;
    config["evStsReg02"]    = props;

    mappingClear(props);
    props["hasUnit"]        = true;
    props["hasFormat"]      = true;
    props["hasSmooth"]      = true;
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.PosSt";
    props["dataType"]       = CPC_FLOAT;
    config["PosSt"]         = props;

    mappingClear(props);
    props["hasSmooth"]      = true;
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.PosRSt";
    props["dataType"]       = CPC_FLOAT;
    config["PosRSt"]         = props;

    mappingClear(props);
    props["hasSmooth"]      = true;
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.MaxPosSt";
    props["dataType"]       = CPC_FLOAT;
    config["MaxPosSt"]      = props;

    mappingClear(props);
    props["hasSmooth"]      = true;
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.MPosRSt";
    props["dataType"]       = CPC_FLOAT;
    config["MPosRSt"]       = props;

    mappingClear(props);
    props["hasSmooth"]      = true;
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.AuPosRSt";
    props["dataType"]       = CPC_FLOAT;
    config["AuPosRSt"]      = props;

    mappingClear(props);
    props["hasSmooth"]      = true;
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.AuVoTOfSt";
    props["dataType"]       = CPC_FLOAT;
    config["AuVoTOfSt"]     = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.AuCCRSt";
    props["dataType"]       = CPC_INT16;
    config["AuCCRSt"]       = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.AuDMoRSt";
    props["dataType"]       = CPC_INT16;
    config["AuDMoRSt"]      = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.AuVoTMRSt";
    props["dataType"]       = CPC_INT16;
    config["AuVoTMRSt"]     = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.MVoTMRSt";
    props["dataType"]       = CPC_INT16;
    config["MVoTMRSt"]      = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.MDMoRSt";
    props["dataType"]       = CPC_INT16;
    config["MDMoRSt"]       = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.MCCRSt";
    props["dataType"]       = CPC_INT16;
    config["MCCRSt"]        = props;

    mappingClear(props);
    props["hasUnit"]        = true;
    props["hasFormat"]      = true;
    props["hasSmooth"]      = true;
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.VoTSt";
    props["dataType"]       = CPC_FLOAT;
    config["VoTSt"]         = props;

    mappingClear(props);
    props["hasSmooth"]      = true;
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.ActOutOV";
    props["dataType"]       = CPC_FLOAT;
    config["ActOutOV"]      = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.ActDMo";
    props["dataType"]       = CPC_INT16;
    config["ActDMo"]        = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["hasDescription"] = true;
    props["address"]        = ".ProcessInput.ActCC";
    props["dataType"]       = CPC_INT16;
    config["ActCC"]         = props;

    mappingClear(props);
    props["hasArchive"]     = true;
    props["address"]        = ".ProcessInput.ActVoTMo";
    props["dataType"]       = CPC_INT16;
    config["ActVoTMo"]      = props;

    mappingClear(props);
    props["address"]        = ".ProcessInput.StartISt";
    props["dpe"]            = "StsReg01";
    props["bitPosition"]    = UN_STSREG01_STARTIST;
    props["isAlarm"]        = true;
    config["StartISt"]      = props;

    mappingClear(props);
    props["address"]        = ".ProcessInput.TStopISt";
    props["dpe"]            = "StsReg01";
    props["bitPosition"]    = CPC_STSREG01_TSTOPIST;
    props["isAlarm"]        = true;
    config["TStopISt"]      = props;

    mappingClear(props);
    props["address"]        = ".ProcessInput.FuStopISt";
    props["dpe"]            = "StsReg02";
    props["bitPosition"]    = CPC_STSREG02_FUSTOPIST;
    props["isAlarm"]        = true;
    config["FuStopISt"]     = props;

    mappingClear(props);
    props["address"]        = ".ProcessInput.AlSt";
    props["dpe"]            = "StsReg01";
    props["bitPosition"]    = CPC_STSREG01_ALST;
    props["isAlarm"]        = true;
    config["AlSt"]          = props;

    mappingClear(props);
    props["address"]        = ".ProcessOutput.ManReg01";
    props["dataType"]       = CPC_UINT16;
    config["ManReg01"]      = props;

    mappingClear(props);
    props["address"]        = ".ProcessOutput.MPosR";
    props["dataType"]       = CPC_FLOAT;
    config["MPosR"]         = props;

    mappingClear(props);
    props["address"]        = ".ProcessOutput.MDMoR";
    props["dataType"]       = CPC_UINT16;
    config["MDMoR"]         = props;

    mappingClear(props);
    props["address"]        = ".ProcessOutput.MCCR";
    props["dataType"]       = CPC_UINT16;
    config["MCCR"]          = props;

    mappingClear(props);
    props["address"]        = ".ProcessOutput.MVoTMoR";
    props["dataType"]       = CPC_UINT16;
    config["MVoTMoR"]       = props;
//end_TAG_SCRIPT_DEVICE_TYPE_deviceConfig

  return config;
}

/**
Returns the list of parameter names that passed via config line.
*/
dyn_string CPC_MassFlowControllerConfig_getParamNames() {
//begin_TAG_SCRIPT_DEVICE_TYPE_getParamNames
    return makeDynString(CPC_PARAMS_MRESTART, CPC_PARAMS_RSTARTFS, CPC_PARAMS_FSPOSON, CPC_PARAMS_NOISE_FILTER, CPC_PARAMS_FEEDBACK_SIM, CPC_PARAMS_INHIBITMANUALTOTALIZER);
//end_TAG_SCRIPT_DEVICE_TYPE_getParamNames
}

/**
Check data before configuration
  @param[in]  configLine   Configs (see dyn_string indexes in constants defined)
  @param[out] exceptionInfo All possible errors will be returned here
*/
CPC_MassFlowControllerConfig_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  if (dynlen(configLine) >= UN_CONFIG_COMMON_LENGTH) {
    // 1. Common
    unConfigGenericFunctions_checkParameters(configLine, UN_CONFIG_CPC_MASSFLOWCONTROLLER_DPT_NAME, exceptionInfo);
    // 2. call the device check function
    unConfigGenericFunctions_checkDeviceConfig(configLine, UN_CONFIG_CPC_MASSFLOWCONTROLLER_DPT_NAME, exceptionInfo);
  } else {
    fwException_raise(exceptionInfo,"ERROR","CPC_MassFlowControllerConfig_checkConfig: " + getCatStr("unGeneration","BADINPUTS"),"");
  }
}

/**
Check the CPC_MassFlowController device configuration for the S7_PLC front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
S7_PLC_CPC_MassFlowController_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_checkDeviceConfig(UN_CONFIG_CPC_MASSFLOWCONTROLLER_DPT_NAME, configLine, exceptionInfo);
}

/**
Check the CPC_MassFlowController device configuration for the _UnPlc front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
_UnPlc_CPC_MassFlowController_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_checkDeviceConfig(UN_CONFIG_CPC_MASSFLOWCONTROLLER_DPT_NAME, configLine, exceptionInfo);
}

/**
Creates dp (or checks if it is already presented)and sets configuration for CPC_MassFlowController object.
  
  @param[in]  dsConfigs   Configs (see dyn_string indexes in constants defined)
    dsConfigs is the addition of the file configuration line + additional parameters needed for PVSS. These additional parameters
    are added during the import process. Their contents can be accessed using constants defined in unConfigGenericFunctions.ctl library
  @param[out] exceptionInfo All possible errors will be returned here
*/
CPC_MassFlowControllerConfig_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  string sDpName;

  // 1. Initialization : checking + dpCreate
  unConfigGenericFunctions_checkAll(dsConfigs, UN_CONFIG_CPC_MASSFLOWCONTROLLER_DPT_NAME, exceptionInfo);
  if (dynlen(exceptionInfo) <= 0) { // Good inputs 
    sDpName = dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME];
    unConfigGenericFunctions_createDp(sDpName, UN_CONFIG_CPC_MASSFLOWCONTROLLER_DPT_NAME, exceptionInfo);
    if (dynlen(exceptionInfo) <= 0) { // Creation ok or dp already exists
      // 2. Generate device
      // 2.1. Parameters
      unConfigGenericFunctions_setCommon(dsConfigs, exceptionInfo);
      // 2.2 call the device check function
      unConfigGenericFunctions_setDeviceConfig(dsConfigs, UN_CONFIG_CPC_MASSFLOWCONTROLLER_DPT_NAME, exceptionInfo);
    }
  }
}

/**
Set the CPC_MassFlowController device configuration for the S7_PLC front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
S7_PLC_CPC_MassFlowController_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_setDeviceConfig(dsConfigs, exceptionInfo);
}

/**
Set the CPC_MassFlowController device configuration for the _UnPlc front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
_UnPlc_CPC_MassFlowController_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_setDeviceConfig(dsConfigs, exceptionInfo);
}

/** Set custom configuration
*/
CPC_MassFlowControllerConfig_setCustomConfig(dyn_string dsConfigs, bool hasArchive, dyn_string &exceptionInfo)
{
//begin_TAG_SCRIPT_DEVICE_TYPE_setCustomConfig
    unConfigGenericFunctions_setDescription(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessInput.ActDMo", "1=Close,2=Min,3=Regulated,4=Max,5=Open", exceptionInfo);
    if (dynlen(exceptionInfo) > 0) {
        fwException_raise(exceptionInfo,"ERROR","CPC_MassFlowControllerConfig_setCustomConfig: Set new description (ActDMo)- ","");
        return;
    }

    unConfigGenericFunctions_setDescription(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessInput.ActVoTMo", "1=Stop,2=Start,3=Reset", exceptionInfo);
    if (dynlen(exceptionInfo) > 0) {
        fwException_raise(exceptionInfo,"ERROR","CPC_MassFlowControllerConfig_setCustomConfig: Set new description (ActVoTMo)- ","");
        return;
    }

    unGenericDpFunctions_setKeyDeviceConfiguration(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME], CPC_MFC_CALIBRATION_UNIT, makeDynString(dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_MASSFLOWCONTROLLER_CALIB_UNIT]), exceptionInfo);
    if (dynlen(exceptionInfo) > 0) {
        fwException_raise(exceptionInfo,"ERROR","CPC_MassFlowControllerConfig_setCustomConfig: can't set calibration gas unit ","");
        return;
    }
    unGenericDpFunctions_setKeyDeviceConfiguration(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME], CPC_MFC_CALIBRATION_GAS_NAME, makeDynString(dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_MASSFLOWCONTROLLER_CALIB_GAS_NAME]), exceptionInfo);
    if (dynlen(exceptionInfo) > 0) {
        fwException_raise(exceptionInfo,"ERROR","CPC_MassFlowControllerConfig_setCustomConfig: can't set calibration gas name ","");
        return;
    }
//end_TAG_SCRIPT_DEVICE_TYPE_setCustomConfig
}

/**
Purpose: Export CPC_MassFlowController Devices

Usage: External function

PVSS manager usage: NG, NV
*/
CPC_MassFlowControllerConfig_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    string sObject = UN_CONFIG_CPC_MASSFLOWCONTROLLER_DPT_NAME;
    int amount = dynlen(dsDpList);
    for(int i = 1; i <= amount; i++) {
        dyn_string dsDpParameters;
        string currentDP = dsDpList[i];

        if(!dpExists(currentDP)) continue;

        unExportDevice_getAllCommonParameters(currentDP, sObject, dsDpParameters);
//begin_TAG_SCRIPT_DEVICE_TYPE_export
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getFormat(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getDeadband(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.VoTSt");
        cpcExportGenericFunctions_getFormat(currentDP, dsDpParameters, ".ProcessInput.VoTSt");
        cpcExportGenericFunctions_getDeadband(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.VoTSt");
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters, ".ProcessInput.VoTSt");
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters, ".ProcessInput.AuCCRSt");
        cpcExportGenericFunctions_getDigitalNormalPosition(currentDP, sObject, makeDynString(".ProcessInput.StartISt", ".ProcessInput.TStopISt", ".ProcessInput.FuStopISt"), dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "StsReg01",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "StsReg02",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "evStsReg01",  true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "evStsReg02",  true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "PosSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "PosRSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MaxPosSt",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MPosRSt",     true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "AuPosRSt",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "AuVoTOfSt",   true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "AuCCRSt",     true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "AuDMoRSt",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "AuVoTMRSt",   true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MVoTMRSt",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MDMoRSt",     true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MCCRSt",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "VoTSt",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ActOutOV",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ActDMo",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ActCC",       true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ActVoTMo",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ManReg01",    false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MPosR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MDMoR",       false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MCCR",        false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MVoTMoR",     false, dsDpParameters);
        dynAppend(dsDpParameters, dpGetDescription(currentDP + ".ProcessInput.ActCC"));
        cpcExportGenericFunctions_getKeyDeviceConfiguration(currentDP, dsDpParameters, CPC_MFC_CALIBRATION_UNIT, exceptionInfo);
        cpcExportGenericFunctions_getKeyDeviceConfiguration(currentDP, dsDpParameters, CPC_MFC_CALIBRATION_GAS_NAME, exceptionInfo);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_1, makeDynString(), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_2, makeDynString("ProcessInput.PosSt", "ProcessInput.MaxPosSt", "ProcessInput.MPosRSt", "ProcessInput.AuPosRSt", "ProcessInput.AuVoTOfSt", "ProcessInput.VoTSt", "ProcessInput.ActOutOV"), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_3, makeDynString("ProcessInput.evStsReg01", "ProcessInput.evStsReg02"), dsDpParameters);
        cpcExportGenericFunctions_getMaskEvent(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getParameters(currentDP, dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getMetainfo(currentDP, dsDpParameters, exceptionInfo);
//end_TAG_SCRIPT_DEVICE_TYPE_export

        unExportDevice_writeDsStringToFile(dsDpParameters, UN_PARAMETER_DELIMITER);
    }
}

/**
Purpose: Export CPC_MassFlowController Devices for S7_PLC front-end

Usage: External function

PVSS manager usage: NG, NV
*/
S7_PLC_CPC_MassFlowController_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    CPC_MassFlowControllerConfig_ExportConfig(dsDpList, exceptionInfo);
}

/**
Purpose: Export CPC_MassFlowController Devices for _UnPlc front-end

Usage: External function

PVSS manager usage: NG, NV
*/
_UnPlc_CPC_MassFlowController_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    CPC_MassFlowControllerConfig_ExportConfig(dsDpList, exceptionInfo);
}

//@}